#define private public
#include <PSX/System/IOPorts/interrupt_io.hpp>
#include <PSX/System/IOPorts/timer_io.hpp>
#include <PSX/System/syscalls.h>
#include <PSX/Timer/timer.hpp>
#undef private

namespace JabyEngine {
    volatile size_t GlobalTime :: global_counter = 0;

    namespace Timer {
        static InterruptVerifierResult interrupt_verifier() {
            if(Interrupt::is_irq(Interrupt::Timer2)) {
                return InterruptVerifierResult::ExecuteHandler;
            }
            
            else {
                return InterruptVerifierResult::SkipHandler;
            }
        }

        static void interrupt_handler(uint32_t) {
            GlobalTime::global_counter = GlobalTime::global_counter + 1;

            Interrupt::ack_irq(Interrupt::Timer2);
            __syscall_ReturnFromException();
        }

        InterrupCallback IRQCallback = {
            .next              = nullptr,
            .handler_function  = reinterpret_cast<InterruptHandler>(interrupt_handler),
            .verifier_function = interrupt_verifier
        };
    }
}